/****************************************************************************************/
/*                                    DUDEMEYER.H                                       */
/****************************************************************************************/
/*          (c) 1995 by Magnet Interactive Studios, inc. All rights reserved.           */
/****************************************************************************************/
/*  Revision History:                                                                   */
/*          7/19/94   File first created. By Andrew Looney.                             */
/*  v1.0     8/5/94   First polished version. By Andrew Looney.                         */
/*  v2.0    8/24/94   Seven level version burned onto CD-ROM. By Andrew Looney.         */
/*  v2.1    8/29/94   Comments brought back up to date. By Andrew Looney.               */
/*  v2.2     9/7/94   Sixteen level version. By Andrew Looney.                          */
/*  v2.3    9/23/94   Thirty level version burned onto CD-ROM. By Andrew Looney.        */
/*  v2.4   10/19/94   Fifty level version. By Andrew Looney.                            */
/*  v2.5   10/31/94   Sixty level version burned onto CD-ROM. By Andrew Looney.         */
/*  v3.0   10/31/94   Began switching over to real artwork. By Andrew Looney.           */
/*  v3.1   11/11/94   COMDEX version. By Andrew Looney.                                 */
/*  v3.2    12/2/94   Seventy-five level version. By Andrew Looney.                     */
/*  v3.3   12/14/94   Ack! Zombies! By Andrew Looney.                                   */
/*  v3.4   12/23/94   Orange Meanies! By Andrew Looney.                                 */
/*  v3.5     1/3/95   100 Levels! By Andrew Looney.                                     */
/*  v3.6     1/5/95   101 Levels. By Andrew Looney.                                     */
/*  v3.7    1/16/95   New, improved Brainy Seeker logic! By Andrew Looney.              */
/*  v3.8    1/27/95   114 level version burned onto CD-ROM. By Andrew Looney.           */
/*  v3.9     2/3/95   New CD-ROM burned for shipment to 3DO. By Andrew Looney.          */
/*  v4.0     2/9/95   New CD-ROM featuring the big level grid. By Andrew Looney.        */
/*  v4.1    2/22/95   New CD-ROM with rough draft of full interface. By Andrew Looney.  */
/*  v4.2    3/17/95   The St. Patrick's Day Version. By Andrew Looney.                  */
/*  v4.3    3/20/95   The last version before the movies get added. By Andrew Looney.   */
/*  v4.4    3/21/95   First version with movies integrated. By Andrew Looney.           */
/*  v4.5    3/22/95   Second version with movies integrated. By Andrew Looney.          */
/*  v4.6    3/27/95   Third version with movies integrated. By Andrew Looney.           */
/*  v5.0    3/28/95   Newest version sent to QA. By Andrew Looney.                      */
/*  v5.1    3/28/95   Now, with Easter Eggs! By Andrew Looney.                          */
/*  v5.2    3/29/95   Could this be the final version? By Andrew Looney.                */
/*  v5.3    3/30/95   OK, now maybe THIS is the final version! By Andrew Looney.        */
/*  v5.4     4/3/95   Made a couple more minor changes. By Andrew Looney.               */
/****************************************************************************************/

#define DUDEMEYER_WEST        "$boot/IceFiles/DudemeyerArt/dm5.cel"
#define DUDEMEYER_EAST        "$boot/IceFiles/DudemeyerArt/dm1.cel"
#define DUDEMEYER_SOUTH       "$boot/IceFiles/DudemeyerArt/dm3.cel"
#define DUDEMEYER_NORTH       "$boot/IceFiles/DudemeyerArt/dm7.cel"
#define DUDEMEYER_NE          "$boot/IceFiles/DudemeyerArt/dm8.cel"
#define DUDEMEYER_NW          "$boot/IceFiles/DudemeyerArt/dm6.cel"
#define DUDEMEYER_SE          "$boot/IceFiles/DudemeyerArt/dm2.cel"
#define DUDEMEYER_SW          "$boot/IceFiles/DudemeyerArt/dm4.cel"

#define DUDESHOOTS_WEST       "$boot/IceFiles/DudemeyerArt/dsw.anim"
#define DUDESHOOTS_EAST       "$boot/IceFiles/DudemeyerArt/dse.anim"
#define DUDESHOOTS_SOUTH      "$boot/IceFiles/DudemeyerArt/dss.anim"
#define DUDESHOOTS_NORTH      "$boot/IceFiles/DudemeyerArt/dsn.anim"
#define DUDESHOOTS_NE         "$boot/IceFiles/DudemeyerArt/dsne.anim"
#define DUDESHOOTS_NW         "$boot/IceFiles/DudemeyerArt/dsnw.anim"
#define DUDESHOOTS_SE         "$boot/IceFiles/DudemeyerArt/dsse.anim"
#define DUDESHOOTS_SW         "$boot/IceFiles/DudemeyerArt/dssw.anim"

#define DUDEDEATH_WEST        "$boot/IceFiles/DudemeyerArt/ddw.anim"
#define DUDEDEATH_EAST        "$boot/IceFiles/DudemeyerArt/dde.anim"
#define DUDEDEATH_SOUTH       "$boot/IceFiles/DudemeyerArt/dds.anim"
#define DUDEDEATH_NORTH       "$boot/IceFiles/DudemeyerArt/ddn.anim"
#define DUDEDEATH_NE          "$boot/IceFiles/DudemeyerArt/ddne.anim"
#define DUDEDEATH_NW          "$boot/IceFiles/DudemeyerArt/ddnw.anim"
#define DUDEDEATH_SE          "$boot/IceFiles/DudemeyerArt/ddse.anim"
#define DUDEDEATH_SW          "$boot/IceFiles/DudemeyerArt/ddsw.anim"

#define DUDEMEYER_ANGEL		   "$boot/IceFiles/DudemeyerArt/dmangel.anim"
#define FELL_INTO_PIT_ANIM    "$boot/IceFiles/DudemeyerArt/dmpit.anim"
#define DEATH_BY_LAVA_ANIM    "$boot/IceFiles/DudemeyerArt/dmlava.anim"
#define DEATH_BY_SLIME_ANIM   "$boot/IceFiles/DudemeyerArt/dmslime.anim"

/***** ice handling symbols *****/

#define HORZ_SLIPPERYNESS  11
#define VERT_SLIPPERYNESS  8
#define OFF_THE_ICE        0
#define STATIONARY         1
#define ACCELERATING       2
#define DECCELERATING      3
#define FULL_THROTTLE      4
#define SKIDDING           5

/***** visual state values *****/

#define NORMAL_VIEW			0
#define SHOOTING_VIEW		1
#define ACCELERATING_VIEW	2
#define BRAKING_VIEW			3

/****************************************************************************************/

class dudemeyer 
{
	private:
		CCB   		 *dudemeyer_views[8];
		anim_source	 shooting_sources[8];
		anim_user	 dudemeyer_shooting[8];
		int32 		 col_detect_x[8];
		int32 		 col_detect_y[8];
		int32			 ice_delay_x;
		int32			 ice_delay_y;
		
	public:
		anim_source	 dudemeyer_deaths[8];
		anim_source	 pitfall_death;
		anim_source	 lava_death;
		anim_source	 slime_death;
		anim_source	 angel;
		CCB			 *dudemeyer_cel;
		solid_object *dudemeyer_object;
		int32			 direction;
		int32 		 old_direction;
		int32	 		 vert_speed;
		int32			 horz_speed;
		int32			 ice_movement_state;
		int32			 old_ice_direction;
		int32			 visual_state;

		bool  		 LoadArtwork (void);
		void  		 InitializeDudemeyer (void);		
		void  		 MoveDudemeyer (int32 x_change, int32 y_change);
		bool  		 ChangeDirection (void);
		bool  		 Obstructed (bool deal_with_death);		
		void  		 Vanish (int percentage);
		void 			 IceMovementAdjustments(int32 &x_change,int32 &y_change,uint32 action);
		void 			 UpdateView (int32 new_mode);
		void 			 RestoreView (void);
		void  		 ShutdownForExit (void);
};

/***************************************** EOF ******************************************/
