/****************************************************************************************/
/*                                      NVRAM.H                                         */
/****************************************************************************************/
/*          (c) 1995 by Magnet Interactive Studios, inc. All rights reserved.           */
/****************************************************************************************/
/*  Revision History:                                                                   */
/*           2/2/95   File first created. By Andrew Looney.                             */
/*  v3.9     2/3/95   New CD-ROM burned for shipment to 3DO. By Andrew Looney.          */
/*  v4.0     2/9/95   New CD-ROM featuring the big level grid. By Andrew Looney.        */
/*  v4.1    2/22/95   New CD-ROM with rough draft of full interface. By Andrew Looney.  */
/*  v4.2    3/17/95   The St. Patrick's Day Version. By Andrew Looney.                  */
/*  v4.3    3/20/95   The last version before the movies get added. By Andrew Looney.   */
/*  v4.4    3/21/95   First version with movies integrated. By Andrew Looney.           */
/*  v4.5    3/22/95   Second version with movies integrated. By Andrew Looney.          */
/*  v4.6    3/27/95   Third version with movies integrated. By Andrew Looney.           */
/*  v5.0    3/28/95   Newest version sent to QA. By Andrew Looney.                      */
/*  v5.1    3/28/95   Now, with Easter Eggs! By Andrew Looney.                          */
/*  v5.2    3/29/95   Could this be the final version? By Andrew Looney.                */
/*  v5.3    3/30/95   OK, now maybe THIS is the final version! By Andrew Looney.        */
/*  v5.4     4/3/95   Made a couple more minor changes. By Andrew Looney.               */
/****************************************************************************************/

#define MAGNET_3D0_DEVELOPER_ID_NUMBER		1365
#define NVRAM_FILE_NAME     					"/NVRAM/icebreaker[levelchart]"

#define MAX_FILE_DATA_LENGTH  				84
#define MAX_FILE_NAME_LENGTH  				32
#define MAX_LEVEL_STAT_ELEMENTS				76

#define NVRAM_FULL_MESSAGE     				"$boot/IceFiles/MetaArt/NVRAM_full.cel"
#define YOU_DID_IT_ALL_MESSAGE     			"$boot/IceFiles/MetaArt/congratulations.cel"
#define ARE_YOU_SURE	         				"$boot/IceFiles/MetaArt/are_you_sure.cel"

typedef struct status_file_format
{
	int16 developer_id;
	char  level_stats[MAX_LEVEL_STAT_ELEMENTS];
	int32	difficulty_and_tracks;
};

/****************************************************************************************/

extern void UpdateDifficultyAndTracks (char file_name[]);
extern void FetchDifficultyAndTracks (char file_name[]);
extern bool CheckForVictory(char file_name[],int32 level,int32 number_of_levels_to_check);
extern void FakeCompletion(int32 first_level, int32 last_level);
extern void SetLevelFlagInStatusRecordFile (char file_name[], int32 level, int32 mode);
extern void ZeroOutStatusRecordFile (char file_name[]);
extern void DumpStatusRecordFile (char file_name[]);
extern Err  GetFileBlockSize(Item fileItem, uint32* blockSize);
extern Err  CreateDiskFile(char* fileName, uint32 numberOfBytes);
extern Err  WriteDiskFile(Item fileItem, ubyte *data, int32 numberOfBytes);
extern Err  ReadDiskFile(Item fileItem, ubyte *data, int32 numberOfBytes);
extern Err  SetEndOfFile(Item fileItem, int32 endOfFile);

/***************************************** EOF ******************************************/
