/****************************************************************************************/
/*                                      SOUNDS.H                                        */
/****************************************************************************************/
/*          (c) 1994 by Magnet Interactive Studios, inc. All rights reserved.           */
/****************************************************************************************/
/*  Revision History:                                                                   */
/*          7/20/94   File first created, based on stuff by Mike Chaney.                */
/*  v1.0     8/3/94   First polished version. By Andrew Looney.                         */
/*           8/8/94   Started making changes for next version.                          */
/*  v2.0    8/24/94   Seven level version burned onto CD-ROM. By Andrew Looney.         */
/*  v2.1    8/29/94   Comments brought back up to date. By Andrew Looney.               */
/*  v2.2     9/7/94   Sixteen level version. By Andrew Looney.                          */
/*  v2.3    9/23/94   Thirty level version burned onto CD-ROM. By Andrew Looney.        */
/*  v2.4   10/19/94   Fifty level version. By Andrew Looney.                            */
/*  v2.5   10/31/94   Sixty level version burned onto CD-ROM. By Andrew Looney.         */
/*  v3.0   10/31/94   Began switching over to real artwork. By Andrew Looney.           */
/*  v3.1   11/11/94   COMDEX version. By Andrew Looney.                                 */
/*  v3.2    12/2/94   Seventy-five level version. By Andrew Looney.                     */
/*  v3.3   12/14/94   Ack! Zombies! By Andrew Looney.                                   */
/*  v3.4   12/23/94   Orange Meanies! By Andrew Looney.                                 */
/*  v3.5     1/3/95   100 Levels! By Andrew Looney.                                     */
/*  v3.6     1/5/95   101 Levels. By Andrew Looney.                                     */
/*  v3.7    1/16/95   New, improved Brainy Seeker logic! By Andrew Looney.              */
/*  v3.8    1/27/95   114 level version burned onto CD-ROM. By Andrew Looney.           */
/*  v3.9     2/3/95   New CD-ROM burned for shipment to 3DO. By Andrew Looney.          */
/*  v4.0     2/9/95   New CD-ROM featuring the big level grid. By Andrew Looney.        */
/*  v4.1    2/22/95   New CD-ROM with rough draft of full interface. By Andrew Looney.  */
/*  v4.2    3/17/95   The St. Patrick's Day Version. By Andrew Looney.                  */
/*  v4.3    3/20/95   The last version before the movies get added. By Andrew Looney.   */
/*  v4.4    3/21/95   First version with movies integrated. By Andrew Looney.           */
/*          3/22/95   Altered to enable dynamic loading of sound fx. By Mark Emon.      */
/*  v4.5    3/22/95   Second version with movies integrated. By Andrew Looney.          */
/*  v4.6    3/27/95   Third version with movies integrated. By Andrew Looney.           */
/*  v5.0    3/28/95   Newest version sent to QA. By Andrew Looney.                      */
/*  v5.1    3/28/95   Now, with Easter Eggs! By Andrew Looney.                          */
/*  v5.2    3/29/95   Could this be the final version? By Andrew Looney.                */
/*  v5.3    3/30/95   OK, now maybe THIS is the final version! By Andrew Looney.        */
/*  v5.4     4/3/95   Made a couple more minor changes. By Andrew Looney.               */
/****************************************************************************************/

#ifndef SOUNDS
#define SOUNDS 1

#define CONCRETE_CHIP_SOUND     0
#define ZOMBIE_HIT_SOUND 		  1
#define ZOMBIE_BIRTH_SOUND 	  2
#define SHATTER_SOUND           3
#define LAVA_SIZZLE_SOUND       4
#define SPLAT_SOUND             5
#define ORANGE_HIT_SOUND 		  6
#define LTBLUE_DEATH_SOUND      7
#define ZAP_SOUND               8
#define SHOOT_SOUND             9
#define ERODE_SOUND            10
#define PULVERIZE_SOUND        11
#define PING_SOUND             12
#define PIT_RUMBLE_SOUND       13
#define PINK_DEATH_SOUND       14
#define FALLING_SOUND	       15
#define CONCRETE_CRUMBLE_SOUND 16
#define ZOMBIE_DEATH_SOUND		 17
#define CHAM_ACTIVIATION_SOUND 18
#define DEATH_SOUND				 19
#define DUDEMEYER_SLIME_SOUND	 20
#define LURKER_DEATH_SOUND		 21
#define SKID_SOUND				 22
#define LIME_DEATH_SOUND		 23
#define MAXPROGRAMNUM          24 /* This should be one greater than the last sound */

#define MAX_SCORE_VOICES       8 
#define MIXER_NAME             ("mixer8x2.dsp")
#define MIXER_AMPLITUDE        ((MAXDSPAMPLITUDE/MAX_SCORE_VOICES) * 9)

/* Note: Raise the value of MIXER_AMPLITUDE until the sound clips, then drop it till    */
/* you feel safe. MAXDSPAMPLITUDE/MAX_SCORE_VOICES is guaranteed safe if all you are    */
/* doing is playing scores.                                                             */

static char *SoundEffectsNames[MAXPROGRAMNUM] =
{
	"$boot/IceFiles/Sounds/ConcrHit.AIF",
	"$boot/IceFiles/Sounds/ZombieDamage.AIF",
	"$boot/IceFiles/Sounds/ZombieBirth.AIF",
	"$boot/IceFiles/Sounds/NewREVBlueDeath.AIF", 
	"$boot/IceFiles/Sounds/PlayerLavaDeath.AIF", 
	"$boot/IceFiles/Sounds/NewSplatt.AIF", 
	"$boot/IceFiles/Sounds/OrangeHit.AIF",
	"$boot/IceFiles/Sounds/CyanDeath.AIF",
	"$boot/IceFiles/Sounds/NewREVRedDeath.AIF",
	"$boot/IceFiles/Sounds/NewREVShoot.AIF", 
	"$boot/IceFiles/Sounds/YellowDeath.AIF",
	"$boot/IceFiles/Sounds/GreenDeath.AIF",
	"$boot/IceFiles/Sounds/NewREVPing.AIF",
	"$boot/IceFiles/Sounds/PurpleDeath.AIF", 
	"$boot/IceFiles/Sounds/PinkDeath.AIF",
	"$boot/IceFiles/Sounds/SeekerFall.AIF",
	"$boot/IceFiles/Sounds/ConcreteDeath.AIF", 
	"$boot/IceFiles/Sounds/ZombieDeath.AIF",
	"$boot/IceFiles/Sounds/Chameleon.AIF",
	"$boot/IceFiles/Sounds/NewREVUhOh.AIF", 
	"$boot/IceFiles/Sounds/SlimeDeath.AIF",
	"$boot/IceFiles/Sounds/DarkPinkDeath.AIF",
	"$boot/IceFiles/Sounds/Skid.AIF",
	"$boot/IceFiles/Sounds/LimeDeath.AIF"
};
	
	
/*  declare SoundfxNeeded[] and set Sound Effects that will be load at initialization */
static bool SoundfxNeeded[MAXPROGRAMNUM] = {
 	FALSE, /* CONCRETE_CHIP_SOUND  	*/
 	FALSE, /* ZOMBIE_HIT_SOUND 		*/
 	FALSE, /* ZOMBIE_BIRTH_SOUND 	  	*/
 	TRUE,  /* SHATTER_SOUND          */
 	FALSE, /* LAVA_SIZZLE_SOUND      */
 	TRUE,  /* SPLAT_SOUND            */
 	FALSE, /* ORANGE_HIT_SOUND 		*/
 	FALSE, /* LTBLUE_DEATH_SOUND     */
 	TRUE,  /* ZAP_SOUND              */
 	TRUE,  /* SHOOT_SOUND            */
 	FALSE, /* ERODE_SOUND            */
 	TRUE,  /* PULVERIZE_SOUND        */
 	TRUE,  /* PING_SOUND             */
 	FALSE, /* PIT_RUMBLE_SOUND       */
 	FALSE, /* PINK_DEATH_SOUND       */
 	TRUE,  /* FALLING_SOUND     		*/
 	FALSE, /* CONCRETE_CRUMBLE_SOUND */
 	FALSE, /* ZOMBIE_DEATH_SOUND		*/
 	FALSE, /* CHAM_ACTIVIATION_SOUND */
	TRUE,  /* DEATH_SOUND				*/
 	FALSE, /* DUDEMEYER_SLIME_SOUND	*/
 	FALSE, /* LURKER_DEATH_SOUND		*/
 	FALSE, /* SKID_SOUND				 	*/
 	FALSE  /* LIME_DEATH_SOUND			*/
}; 

/***** Prototypes *****/

extern ScoreContext*  pmfSetupScoreContext ( void );
extern Err            pmfCleanupScoreContext (ScoreContext *scon);
extern bool           InitAudio ( void );
extern void           ReleaseAudio (void);
extern void           PlaySoundEffect (int32 sound_id);
extern void           EndSoundEffect (int32 sound_id);
extern void				 DynamicSampleLoader( bool *SoundfxNeeded );

#endif

/************************************* EOF **********************************************/
