/****************************************************************************************/
/*                                     USERIF.H                                         */
/****************************************************************************************/
/*          (c) 1995 by Magnet Interactive Studios, inc. All rights reserved.           */
/****************************************************************************************/
/*  Revision History:                                                                   */
/*          2/13/95   File first created. By Andrew Looney.                             */
/*  v4.1    2/22/95   New CD-ROM with rough draft of full interface. By Andrew Looney.  */
/*  v4.2    3/17/95   The St. Patrick's Day Version. By Andrew Looney.                  */
/*  v4.3    3/20/95   The last version before the movies get added. By Andrew Looney.   */
/*  v4.4    3/21/95   First version with movies integrated. By Andrew Looney.           */
/*  v4.5    3/22/95   Second version with movies integrated. By Andrew Looney.          */
/*  v4.6    3/27/95   Third version with movies integrated. By Andrew Looney.           */
/*  v5.0    3/28/95   Newest version sent to QA. By Andrew Looney.                      */
/*  v5.1    3/28/95   Now, with Easter Eggs! By Andrew Looney.                          */
/*  v5.2    3/29/95   Could this be the final version? By Andrew Looney.                */
/*  v5.3    3/30/95   OK, now maybe THIS is the final version! By Andrew Looney.        */
/*  v5.4     4/3/95   Made a couple more minor changes. By Andrew Looney.               */
/*  v5.5	    5/4/95	 Added a check mark to the level grid screen. By Andrew Looney.    */
/*  v5.6	    5/5/95	 Made a couple of minor, last minute user interface changes.       */
/****************************************************************************************/

#define PLEASE_WAIT_CEL          "$boot/IceFiles/MetaArt/loading.cel"

#define MAIN_MENU_BACKGROUND		"$boot/IceFiles/Menus/MainMenu/mmenu.cel"
#define MAIN_MENU_DUDEMEYER		"$boot/IceFiles/Menus/MainMenu/mmdude.anim"
#define MAIN_MENU_GREEN_PIECE		"$boot/IceFiles/Menus/MainMenu/mmgreen.anim"
#define MAIN_MENU_BLUE_PIECE		"$boot/IceFiles/Menus/MainMenu/mmblue.anim"
#define MAIN_MENU_RED_PIECE		"$boot/IceFiles/Menus/MainMenu/mmred.anim"
#define MAIN_MENU_YELLOW_PIECE	"$boot/IceFiles/Menus/MainMenu/mmyellow.anim"
#define MAIN_MENU_PURPLE_PIECE	"$boot/IceFiles/Menus/MainMenu/mmpurple.anim"

#define OPTIONS_BACKGROUND			"$boot/IceFiles/Menus/OptionsMenu/omenu.cel"
#define OPTIONS_DUDEMEYER			"$boot/IceFiles/Menus/OptionsMenu/odude.anim"
#define OPTIONS_GREEN_PIECE		"$boot/IceFiles/Menus/OptionsMenu/ogreen.anim"
#define OPTIONS_PRIME_BLUE_PIECE "$boot/IceFiles/Menus/OptionsMenu/oblue.anim"
#define OPTIONS_ALT_BLUE_PIECE	"$boot/IceFiles/Menus/OptionsMenu/omuff.anim"
#define OPTIONS_RED_PIECE			"$boot/IceFiles/Menus/OptionsMenu/ored.anim"
#define OPTIONS_YELLOW_PIECE		"$boot/IceFiles/Menus/OptionsMenu/oyellow.anim"
#define OPTIONS_PURPLE_PIECE		"$boot/IceFiles/Menus/OptionsMenu/opurple.anim"
#define OPTIONS_CYAN_PIECE			"$boot/IceFiles/Menus/OptionsMenu/oltblue.anim"
#define OPTIONS_SOUND_ON_CEL		"$boot/IceFiles/Menus/OptionsMenu/on.cel"
#define OPTIONS_SOUND_OFF_CEL		"$boot/IceFiles/Menus/OptionsMenu/off.cel"

#define LEVEL_GRID             	"$boot/IceFiles/Menus/levelgrid/chart.cel"
#define EASY_BOX               	"$boot/IceFiles/Menus/levelgrid/yellow.cel"
#define MEDIUM_BOX             	"$boot/IceFiles/Menus/levelgrid/pink.cel"
#define HARD_BOX               	"$boot/IceFiles/Menus/levelgrid/blue.cel"
#define INSANE_BOX             	"$boot/IceFiles/Menus/levelgrid/green.cel"
#define HIGHLIGHT_BOX          	"$boot/IceFiles/Menus/levelgrid/highlight.cel"
#define GRID_MARK_EASY     		"$boot/IceFiles/Menus/levelgrid/easy.cel"
#define GRID_MARK_MEDIUM     		"$boot/IceFiles/Menus/levelgrid/medium.cel"
#define GRID_MARK_HARD     		"$boot/IceFiles/Menus/levelgrid/hard.cel"
#define GRID_MARK_INSANE     		"$boot/IceFiles/Menus/levelgrid/insane.cel"

#define SKILL_MENU_BACKGROUND		"$boot/IceFiles/Menus/DifficultyMenu/difficulty.cel"
#define EASY_MODE_ANIM				"$boot/IceFiles/Menus/DifficultyMenu/easy.anim"
#define MEDIUM_MODE_ANIM			"$boot/IceFiles/Menus/DifficultyMenu/medium.anim"
#define HARD_MODE_ANIM				"$boot/IceFiles/Menus/DifficultyMenu/hard.anim"
#define INSANE_MODE_ANIM			"$boot/IceFiles/Menus/DifficultyMenu/insane.anim"
#define INSANE_FALLING_ANIM		"$boot/IceFiles/Menus/DifficultyMenu/insanefall.anim"
#define EASY_BUTTON					"$boot/IceFiles/Menus/DifficultyMenu/easy.cel"
#define MEDIUM_BUTTON				"$boot/IceFiles/Menus/DifficultyMenu/medium.cel"
#define HARD_BUTTON					"$boot/IceFiles/Menus/DifficultyMenu/hard.cel"
#define INSANE_BUTTON				"$boot/IceFiles/Menus/DifficultyMenu/insane.cel"
#define EASY_UNDERLINE     		"$boot/IceFiles/Menus/DifficultyMenu/easyline.cel"
#define MEDIUM_UNDERLINE     		"$boot/IceFiles/Menus/DifficultyMenu/mediumline.cel"
#define HARD_UNDERLINE     		"$boot/IceFiles/Menus/DifficultyMenu/hardline.cel"
#define INSANE_UNDERLINE     		"$boot/IceFiles/Menus/DifficultyMenu/insaneline.cel"

#define MUSIC_STANDARD_CEL			"$boot/IceFiles/Menus/MusicMenu/mo_on.cel"
#define MUSIC_OFF_CEL				"$boot/IceFiles/Menus/MusicMenu/mo_off.cel"
#define MUSIC_CUSTOM_CEL			"$boot/IceFiles/Menus/MusicMenu/mo_on_custom.cel"
#define CHECK_MARK_CEL				"$boot/IceFiles/Menus/MusicMenu/arrow.cel"
#define TRACK_HIGHLIGHT_CEL		"$boot/IceFiles/Menus/MusicMenu/customhilite.cel"
#define MODE_HIGHLIGHT_CEL			"$boot/IceFiles/Menus/MusicMenu/hilite.cel"

#define TUTORIAL_MENU_BACKGROUND	"$boot/IceFiles/Menus/TutorialMenu/tutorials.cel"
#define TUTORIAL_BLUE_BUTTON		"$boot/IceFiles/Menus/TutorialMenu/blue.cel"
#define TUTORIAL_RED_BUTTON		"$boot/IceFiles/Menus/TutorialMenu/red.cel"
#define TUTORIAL_GREEN_BUTTON		"$boot/IceFiles/Menus/TutorialMenu/green.cel"
#define TUTORIAL_YELLOW_BUTTON	"$boot/IceFiles/Menus/TutorialMenu/yellow.cel"

#define PRE_LEVEL_BACKGROUND  	"$boot/IceFiles/Menus/GetReady/get_ready.cel"
#define PRE_LEVEL_EASY  			"$boot/IceFiles/Menus/GetReady/geteasy.cel"
#define PRE_LEVEL_MEDIUM  			"$boot/IceFiles/Menus/GetReady/getmedium.cel"
#define PRE_LEVEL_HARD  			"$boot/IceFiles/Menus/GetReady/gethard.cel"
#define PRE_LEVEL_INSANE  			"$boot/IceFiles/Menus/GetReady/getinsane.cel"
#define PRE_LEVEL_PYRAMIDS			"$boot/IceFiles/Menus/GetReady/numberof.cel"
#define PRE_LEVEL_MENU_BAR			"$boot/IceFiles/Menus/GetReady/getmenu.cel"

#define POST_LEVEL_BACKGROUND  	"$boot/IceFiles/Menus/PostLevel/end_of_level.cel"
#define POST_LEVEL_EASY			  	"$boot/IceFiles/Menus/PostLevel/endeasy.cel"
#define POST_LEVEL_MEDIUM		  	"$boot/IceFiles/Menus/PostLevel/endmedium.cel"
#define POST_LEVEL_HARD			  	"$boot/IceFiles/Menus/PostLevel/endhard.cel"
#define POST_LEVEL_INSANE		  	"$boot/IceFiles/Menus/PostLevel/endinsane.cel"
#define POST_LEVEL_NRL		  		"$boot/IceFiles/Menus/PostLevel/NRL.cel"
#define POST_LEVEL_LC		  		"$boot/IceFiles/Menus/PostLevel/LC.cel"
#define POST_LEVEL_LNC		  		"$boot/IceFiles/Menus/PostLevel/LNC.cel"
#define POST_LEVEL_PTLA		  		"$boot/IceFiles/Menus/PostLevel/PTLA.cel"
#define POST_LEVEL_PLO		  		"$boot/IceFiles/Menus/PostLevel/PLO.cel"
#define POST_LEVEL_PNT		  		"$boot/IceFiles/Menus/PostLevel/PNT.cel"
#define POST_LEVEL_PTNL		  		"$boot/IceFiles/Menus/PostLevel/PTNL.cel"

#define MOVIE_MENU_BACKGROUND		"$boot/IceFiles/Menus/MovieMenu/play_a_movie.cel"
#define MOVIE_MENU_HIGHLIGHT		"$boot/IceFiles/Menus/MovieMenu/hilite.cel"
#define SORRY_MESSAGE   			"$boot/IceFiles/Menus/MovieMenu/access_denied.cel"

#define CREDITS_PAGE_1				"$boot/IceFiles/Menus/Credits/credits1.cel"
#define CREDITS_PAGE_2				"$boot/IceFiles/Menus/Credits/credits2.cel"
#define CREDITS_PAGE_3				"$boot/IceFiles/Menus/Credits/credits3.cel"
#define CREDITS_PAGE_4				"$boot/IceFiles/Menus/Credits/credits4.cel"

#define FONTFILENAME					"$boot/IceFiles/MetaArt/Helvetica.3DO"	
#define FONT_HEIGHT_ALLOWANCE 	15
#define FONT_LEFT_MARGIN			25
#define FONT_TOP_MARGIN				11

#define MAX_TEXT_CELS				7

#define VERSION_TEXT					0
#define EXTRA_LIVES_TEXT			1
#define PAUSED_A_OPTION				2
#define PAUSED_B_OPTION				3
#define PAUSED_X_OPTION				4
#define PAUSED_P_OPTION				5
#define PYRAMIDS_LEFT_TEXT			6
#define PYRAMIDS_ONLY_TEXT			7
#define LEVEL_NAME_TEXT				8
#define LEVEL_NUMBER_TEXT			9
#define SEEKERS_LEFT_TEXT			10
#define MAX_TEXT_MESSAGES			11

#define PLAY_THIS_LEVEL_AGAIN		0
#define PLAY_THE_NEXT_LEVEL		1
#define PLAY_NEXT_TUTORIAL			2
#define PLAY_LEVEL_ONE				3

#define YELLOW_CHOICE 				0
#define PURPLE_CHOICE 				1
#define BLUE_CHOICE 					2
#define RED_CHOICE 					3
#define GREEN_CHOICE 				4
#define CYAN_CHOICE 					5

// RGB settings for a transparent background
#define	TRANSPARENT_BG_REDVALUE				0			
#define	TRANSPARENT_BG_GREENVALUE			0
#define	TRANSPARENT_BG_BLUEVALUE			0

// RGB settings for a white foreground	
#define	WHITE_FG_REDVALUE				65535		
#define	WHITE_FG_GREENVALUE			65535
#define	WHITE_FG_BLUEVALUE			65535

// what's next states
#define  PLAY_THE_GAME			1
#define  PLAY_AGAIN				2
#define  PLAY_A_RANDOM_LEVEL	3
#define  GOTO_OPTIONS			4
#define  GOTO_GRID				5
#define  GOTO_MAIN_MENU			6
#define  GOTO_TUTORIAL_MENU	7
#define  GOTO_DEMO_MODE			8
#define  GOTO_SELF_PLAY_MODE	9
#define  GO_PLAY_A_MOVIE		10
#define  ROLL_THE_CREDITS		11
#define  GOTO_MUSIC_MENU		12
#define  GOTO_SKILL_MENU		13
#define  EXIT_THE_PROGRAM		14

/****************************************************************************************/

extern void  DrawCelHere(CCB *cel_to_draw, int32 x, int32 y);
extern CCB*  LoadIcebreakerTextIntoCel(int32 text_message_id, int32 x, int32 y);
extern void  DisplaySplashScreen(char *splash_screen_file);
extern void  DisplayMessageScreen(char *message_screen_file);
extern bool  VerifyAction(char *are_you_sure_file);
extern void  DrawLevelCompletedBox (int32 level, int32 mode);
extern int32 MainMenuInterface(void);
extern int32 OptionsInterface(void);
extern void  ConstructLevelsCompletedScreen(void);
extern int32 DisplayLevelsCompletedScreen (char file_name[]);
extern void  PreGetReadyScreen(void);
extern int32 GetReadyScreen(void);
extern int32 GameResultsScreen(void);
extern int32 SelectTutorial(void);
extern int32 ChangeSkillLevel(void);
extern int32 PlayMoviesMenu(void);
extern int32 RollTheCredits(void);
extern int32 MusicMenu(void);
extern void  DrawTextHere(char *display_text, int32 x, int32 y);

/***************************************** EOF ******************************************/
