/****************************************************************************************/
/*                                     WEAPON.H                                         */
/****************************************************************************************/
/*          (c) 1995 by Magnet Interactive Studios, inc. All rights reserved.           */
/****************************************************************************************/
/*  Revision History:                                                                   */
/*          7/20/94   File first created. By Andrew Looney.                             */
/*  v1.0     8/5/94   First polished version. By Andrew Looney.                         */
/*  v2.0    8/24/94   Seven level version burned onto CD-ROM. By Andrew Looney.         */
/*  v2.1    8/29/94   Comments brought back up to date. By Andrew Looney.               */
/*  v2.2     9/7/94   Sixteen level version. By Andrew Looney.                          */
/*  v2.3    9/23/94   Thirty level version burned onto CD-ROM. By Andrew Looney.        */
/*  v2.4   10/19/94   Fifty level version. By Andrew Looney.                            */
/*  v2.5   10/31/94   Sixty level version burned onto CD-ROM. By Andrew Looney.         */
/*  v3.0   10/31/94   Began switching over to real artwork. By Andrew Looney.           */
/*  v3.1   11/11/94   COMDEX version. By Andrew Looney.                                 */
/*  v3.2    12/2/94   Seventy-five level version. By Andrew Looney.                     */
/*  v3.3   12/14/94   Ack! Zombies! By Andrew Looney.                                   */
/*  v3.4   12/23/94   Orange Meanies! By Andrew Looney.                                 */
/*  v3.5     1/3/95   100 Levels! By Andrew Looney.                                     */
/*  v3.6     1/5/95   101 Levels. By Andrew Looney.                                     */
/*  v3.7    1/16/95   New, improved Brainy Seeker logic! By Andrew Looney.              */
/*  v3.8    1/27/95   114 level version burned onto CD-ROM. By Andrew Looney.           */
/*  v3.9     2/3/95   New CD-ROM burned for shipment to 3DO. By Andrew Looney.          */
/*  v4.0     2/9/95   New CD-ROM featuring the big level grid. By Andrew Looney.        */
/*  v4.1    2/22/95   New CD-ROM with rough draft of full interface. By Andrew Looney.  */
/*  v4.2    3/17/95   The St. Patrick's Day Version. By Andrew Looney.                  */
/*  v4.3    3/20/95   The last version before the movies get added. By Andrew Looney.   */
/*  v4.4    3/21/95   First version with movies integrated. By Andrew Looney.           */
/*  v4.5    3/22/95   Second version with movies integrated. By Andrew Looney.          */
/*  v4.6    3/27/95   Third version with movies integrated. By Andrew Looney.           */
/*  v5.0    3/28/95   Newest version sent to QA. By Andrew Looney.                      */
/*  v5.1    3/28/95   Now, with Easter Eggs! By Andrew Looney.                          */
/*  v5.2    3/29/95   Could this be the final version? By Andrew Looney.                */
/*  v5.3    3/30/95   OK, now maybe THIS is the final version! By Andrew Looney.        */
/*  v5.4     4/3/95   Made a couple more minor changes. By Andrew Looney.               */
/****************************************************************************************/

#define FIREBALL_EAST         "$boot/IceFiles/FireballArt/fireball_e.anim"
#define FIREBALL_WEST         "$boot/IceFiles/FireballArt/fireball_w.anim"
#define FIREBALL_NORTH        "$boot/IceFiles/FireballArt/fireball_n.anim"
#define FIREBALL_SOUTH        "$boot/IceFiles/FireballArt/fireball_s.anim"
#define FIREBALL_NORTHEAST    "$boot/IceFiles/FireballArt/fireball_ne.anim"
#define FIREBALL_NORTHWEST    "$boot/IceFiles/FireballArt/fireball_nw.anim"
#define FIREBALL_SOUTHEAST    "$boot/IceFiles/FireballArt/fireball_se.anim"
#define FIREBALL_SOUTHWEST    "$boot/IceFiles/FireballArt/fireball_sw.anim"
#define FIREBALL_DEATH_ANIM   "$boot/IceFiles/FireballArt/fireballsplat.anim"

#define MAX_BULLETS    			2
#define BULLET_INACTIVE			0
#define BULLET_MOVING			1
#define BULLET_EXPLODING		2

/****************************************************************************************/

class weapon 
{
	private:
		anim_source bullet_source[8];
		anim_user	bullet[MAX_BULLETS];
		int32			bullet_direction[MAX_BULLETS];
		bool  		bullet_state[MAX_BULLETS];
		int32 		step_size;
	
	public:
		int32	speed;
		anim_source		fireball_death;

		bool  LoadArtwork (void);
		void  InitializeWeapon (void);
		bool  FireWeapon (int32 firing_direction);
		bool  DetectHit (int32 bullet_number);
		void  MoveBullets (int32 x_change, int32 y_change);
		void  DrawBullets (void);
		void  UndrawBullets (void);
		void  StopBullets (void);
		bool  DivineIntervention (solid_object *potential_victim);
		void  ShutdownForRestart (void);
		void  ShutdownForExit (void);
};

/***************************************** EOF ******************************************/
